uniform sampler2D ShadowMap, tex2d;

varying vec4 ShadowCoord;

void main()
{	

	vec3 ct,cf,c;
	vec4 texel;
	vec4 shadowCoordinateWdivide = ShadowCoord / ShadowCoord.w ;
	
	// Used to lower moiré pattern and self-shadowing
	shadowCoordinateWdivide.z += 0.0005;
	
	
	float distanceFromLight = texture2D(ShadowMap,shadowCoordinateWdivide.st).z;
	//	uniform float xPixelOffset ;
	//
	//// This define the value to move one pixel up or down
	//uniform float yPixelOffset ;
	//
	//float lookup( vec2 offSet)
	//{
	//	// Values are multiplied by ShadowCoord.w because shadow2DProj does a W division for us.
	//	return shadow2DProj(ShadowMap, ShadowCoord + vec4(offSet.x * xPixelOffset * ShadowCoord.w, offSet.y * yPixelOffset * ShadowCoord.w, 0.05, 0.0) ).w;
	//}
	
 	float shadow = 0.0;
	float at,af,a;
 	if (ShadowCoord.w > 0.0)
 		shadow = distanceFromLight < shadowCoordinateWdivide.z ? 0.5 : 1.0 ;

	//if (ShadowCoord.w > 1.0)
	//	{
	//		float x,y;
	//		for (y = -1.5 ; y <=1.5 ; y+=1.0)
	//			for (x = -1.5 ; x <=1.5 ; x+=1.0)
	//				shadow += lookup(vec2(x,y));
	//		
	//		shadow /= 16.0 ;
	//
	//	}
	at = texel.a;
		
  	texel = texture2D(tex2d,gl_TexCoord[0].st);
	af = gl_FrontMaterial.diffuse.a;	
	a = af * at;
	ct = texel.rgb;
	ct=ct*shadow;
	
  	gl_FragColor =	vec4(ct,a);
  
}

